openlink/core/urls.py
from django.urls import path, register_converter
from openlink.core import views
from openlink.core.views import items, mapping, projects, publish, tools, users


class FloatConverter:
    regex = r"[\d\.\d]+"

    def to_python(self, value):
        return float(value)

    def to_url(self, value):
        return "{}".format(value)


register_converter(FloatConverter, "float")


app_name = "core"
urlpatterns = [
    path("", projects.projects, name="home"),
    path("about/", views.home, name="about"),
    path("profile/<username>/", views.get_user_profile, name="user-profile"),
    path("contact/", views.contact, name="contact"),
    # projects creation
    path("projects", projects.projects, name="projects"),
    path("projects/new", projects.new_project, name="projects-new"),
    path("projects/add", projects.add_project, name="projects-add"),
    # projects tools
    path(
        "projects/<int:project_id>/tools",
        tools.list_tools_project,
        name="tools-project",
    ),
    path(
        "projects/<int:project_id>/tools/new",
        tools.select_connector_project,
        name="select-connector-project",
    ),
    path(
        "projects/<int:project_id>/tools/<str:connector>",
        tools.add_tool_project,
        name="add-tool-project",
    ),
    path(
        "projects/<int:project_id>/tools/<int:tool_id>/edit_tool",
        tools.ToolUpdate.as_view(),
        name="tools-edit-project",
    ),
    path(
        "projects/<int:project_id>/tool/<int:tool_id>",
        tools.get_tool_info_project,
        name="tool-project",
    ),
    path(
        "projects/<int:project_id>/delete/tool/<int:pk>",
        tools.delete_tool,
        name="delete_tool",
    ),
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    # projects editing
    path(
        "projects/<int:project_id>/edit",
        items.ProjectUpdate.as_view(),
        name="edit-project",
    ),
    path(
        "projects/<int:project_id>/add_user_mapping",
        users.add_user_mapping,
        name="add_user_mapping",
    ),
    path(
        "projects/<int:project_id>/manage_user",
        mapping.mapping_project_user,
        name="mapping_project_user",
    ),
    path(
        "projects/<int:project_id>/delete_user_mapping/<str:pk>",
        mapping.delete_user_mapping,
        name="delete_user_mapping",
    ),
    path("projects/<int:project_id>/", projects.details, name="projects-details"),
    path(
        "projects/<int:project_id>/delete/<str:data_type>/<int:pk>",
        projects.delete,
        name="delete",
    ),
    path(
        "projects/<int:project_id>/add_investigation",
        items.add_investigation,
        name="add-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/edit",
        items.InvestigationUpdate.as_view(),
        name="edit-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/add_study",
        items.add_study,
        name="add-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/edit",
        items.StudyUpdate.as_view(),
        name="edit-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/add_assay",
        items.add_assay,
        name="add-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/edit",
        items.AssayUpdate.as_view(),
        name="edit-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/add_data",
        items.add_data,
        name="add-data",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/edit",
        items.DataUpdate.as_view(),
        name="edit-data",
    ),
    # project investigation map_id item
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/datasets",
    #     mapping.datasets,
    #     name="datasets",
    # ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/studies",
        mapping.studies,
        name="studies",
    ),
    # project investigation map_id select mapping
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/select_data_mapping",
        mapping.select_data_mapping,
        name="select_data_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/select_assay_mapping",
        mapping.select_assay_mapping,
        name="select_assay_mapping",
    ),
    # publish
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # testé quelle route est uttilisé pour choose_meta
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_non_linked_object",
    #     mapping.choose_non_linked_object,
    #     name="choose_non_linked_object",
    # ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(

openlink/urls.py
import debug_toolbar

# from openlink.core.admin import admin_site
from django.contrib import admin
from django.contrib.auth import views
from django.urls import include, path
from rest_framework import routers

from openlink import log_manager
from openlink.core.views import api

admin.site.site_header = "OPENLINK Database administration"
admin.site.site_title = "OPENLINK administration"
admin.site.index_title = "OPENLINK Site Administration"

router = routers.DefaultRouter()
router.register(r"taskinfo", api.TaskinfoViewSet, basename="taskinfo")
router.register(r"access_mapping", api.MappingViewSet, basename="access_mapping")

urlpatterns = [
    path("__debug__/", include(debug_toolbar.urls)),
    path("", include("openlink.core.urls")),
    path("admin/", admin.site.urls),
    path("accounts/login/", log_manager.login_page, name="login"),
    path("accounts/logout/", log_manager.custom_logout, name="logout"),
    path("accounts/", include("django.contrib.auth.urls")),
    path("django-rq/", include("django_rq.urls")),
    path("oidc/", include("mozilla_django_oidc.urls")),
    path("api/", include(router.urls)),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
]

openlink/core/views/api.py
import datetime
import json
import logging

from django.db.models import Q
from django.http import JsonResponse
from openlink.core.models import Mapping, TaskInfo
from openlink.core.serializers import TaskinfoSerializer
from rest_framework import permissions, viewsets


class TaskinfoViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = TaskInfo.objects.all()
    serializer_class = TaskinfoSerializer

    def get_queryset(self):
        queryset = TaskInfo.objects.all()
        project_id = None
        max_lenght = None
        delta_minutes = None
        if self.request.query_params.get("project_id"):
            project_id = int(self.request.query_params.get("project_id"))
        if self.request.query_params.get("max_lenght"):
            max_lenght = int(self.request.query_params.get("max_lenght"))
        if self.request.query_params.get("delta_minutes"):
            delta_minutes = int(self.request.query_params.get("delta_minutes"))
        if project_id is not None:
            queryset = queryset.filter(project__id=project_id)
        if delta_minutes is not None:
            creation_time = datetime.datetime.now() - datetime.timedelta(
                minutes=delta_minutes
            )
            queryset = queryset.filter(
                Q(start_date__gte=creation_time)
                | Q(status="queued")
                | Q(status="started")
            )
        if max_lenght is not None:
            queryset = queryset.order_by("-start_date")[:max_lenght]
        return queryset


class MappingViewSet(viewsets.ViewSet):
    def list(self, request):
        mapping_id = self.request.query_params.get("item_id")
        res = mapping_id.strip("][").split(", ")
        all_results = {}
        list_result = []
        for obj in res:
            dict = {}
            try:
                mapping_object = Mapping.objects.filter(
                    foreign_id_obj__id=obj, type="data"
                )
            except Exception as e:
                logging.debug(e)
                continue
            if mapping_object:
                connector = mapping_object[0].tool_id.get_connector(
                    self.request.session["vault_token"]
                )
                has_access = connector.check_file_access(mapping_object[0].object_id)
                dict["id"] = mapping_object[0].id
                dict["access"] = has_access
                list_result.append(dict)

        all_results["results"] = list_result
        data = json.dumps(all_results)
        return JsonResponse(data, safe=False)

openlink/core/views/users.py
import logging

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from mozilla_django_oidc.auth import OIDCAuthenticationBackend
from openlink.core.forms import AddProjectUserForm
from openlink.core.models import MappingProjectUser, Project

logger = logging.getLogger(__name__)


class OpenLinkOIDCAuthenticationBackend(OIDCAuthenticationBackend):
    def create_user(self, claims):
        user = super(OpenLinkOIDCAuthenticationBackend, self).create_user(claims)
        user.username = claims.get("preferred_username", "")
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user

    def update_user(self, user, claims):
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user


@login_required
def get_access_level(request, project_id):
    # return current user access level for a given project
    access_level = ""
    user = request.user
    try:
        projects_list_user = Project.objects.get(
            author__user=request.user, id=project_id
        )
    except Project.DoesNotExist:
        projects_list_user = None
    if projects_list_user:
        access_level = str("administrator")
    proj_map = (
        MappingProjectUser.objects.filter(user__user=user)
        .filter(project__id=project_id)
        .values()
    )
    if proj_map.exists():
        for value in proj_map:
            access_level = value["role"]
    return access_level


@login_required
def add_user_mapping(request, *args, **kwargs):
    # Select a user to be map to the current project
    current_user = request.user
    current_proj = kwargs["project_id"]
    data_type = "project"
    mpu_list = MappingProjectUser.objects.filter(project__id=current_proj)
    project = get_object_or_404(Project, id=current_proj)

    if request.method == "POST":
        form = AddProjectUserForm(request.POST)
        user_mapping = form.save(commit=False)
        user_mapping.name = str(current_proj) + "_" + str(form.cleaned_data.get("user"))
        user_mapping.project = project
        user_mapping.save()
        messages.info(request, "User " + str(form.cleaned_data.get("user")) + " added")

        return HttpResponseRedirect(
            reverse("core:add_user_mapping", args=[current_proj])
        )

    else:
        form = AddProjectUserForm()

    return render(
        request,
        "mapping/add_user_mapping.html",
        {
            "form": form,
            "current_proj": current_proj,
            "data_type": data_type,
            "current_user": current_user,
            "data_type": data_type,
            "mpu_list": mpu_list,
            "project": project,
        },
    )

openlink/core/templates/tools/add_tool_project.html
{% extends 'base.html' %}
{% load static %}
{% load widget_tweaks %}

{% load crispy_forms_tags %}

{% block content %}
<div class="row col-sm-12">
    <div class="row col-sm-10">
        <h4 class="display-titre" style="background-color: rgb(255, 255, 255)">Add a new "{{ tool_name }}" tool for the project
            "{{project.name}}"</h4>
    </div>
    <div class="row col-sm-2">
        <img class="img_logo_small" src ="{% static logo %}">
    </div>
</div>
<br>
<form action="{% url 'core:add-tool-project' project.id connector %}" method="POST">
    {% csrf_token %}
    <input type="hidden" name="name" id="name" value="{{tool_name}}" />
    {% crispy form form.helper %}

    <div class="form-group">
        <div class="aab col-sm-offset-1 col-sm-2"></div>
        <div class = "col-md-8">
        <button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>
        <button type="submit" class="btn btn-primary">Add Tool</button>
        </div>
    </div>
</form>

{% endblock %}

openlink/core/templates/tools/edit_toolparam_project.html
{% extends 'base.html' %}
{% load static %}
{% load widget_tweaks %}
{% load crispy_forms_tags %}

{% block content %}
<div class="row col-sm-12">
    <div class="row col-sm-10">
        <h4 class="display-titre" style="background-color: rgb(255, 255, 255)">Edit parameters for tool "{{tool.name}}"
        </h4>
    </div>
    <div class="row col-sm-2">
        <img src ="{% static logo %}" style="width:100px">
    </div>
</div>
<br>
<form action="{% url 'core:toolsparam-edit-project' project.id tool.id %}" method="POST">
    {% csrf_token %}
    {% crispy form form.helper %}
</form>
{% endblock %}

openlink/core/templates/tools/form_choose_tool.html
{% extends 'base.html' %}

{% load widget_tweaks %}
{% load param %}
{% block content %}

  <!-- Modal -->
  <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="myModalLabel">Warning</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
            No Tool to be selected
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        </div>
      </div>
    </div>
  </div>


<h4 class="display-titre" style="background-color: rgb(255, 255, 255)">Select Tool</h4>
{% if exist_tool == 0 %}
No tools are available.
<br>
<br>
<button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>
<a class="btn btn-primary" href="{% url 'core:tools-project' project.id %}">Add new tool</a>


{% else %}

{% if form.Name|length < 1 %}
All tools already link to this {{data_type}}
<br>

<button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>


{% else %}

{% if function == "publish" %}
<form action="choose_tool_for_publish" method="post">
    {% else%}
    <form name="choose_tool" action="choose_tool" onsubmit="return validateForm()" method="post">
        {%endif%}
        {% csrf_token %}


        <div class="container">
            <table id="table" data-page-length='25' class="table table-striped table-bordered ">
                <thead class="thead-dark">
                    <tr>
                        <th></th>
                        <th>State</th>
                        <th>Tool name</th>
                        <th>Url host</th>
                        <th>Creation date</th>
                    </tr>
                </thead>
                <tbody>
                    {% for item in all_tool_list  %}
                        {% if item in list_tools_linked %}
                            {% if item not in tools_not_available %}
                            <tr style="text-align: center">
                                <td><input type="radio" name="object_name" value="{{item.id}}" required=""
                                        id="id_object_name_1"></td>
                                <td>Connected</td>
                                <td><i class=""></i>{{item.name}}
                                </td>
                                <td><a href="{{ item|param:'url'}}" target="_blank">{{ item|param:'url' }}</a></td>
                                <td>{{item.date_created}}</td>
                            </tr>
                            {% else %}
                                <tr style="text-align: center; opacity: 0.4">
                                    <td>
                                        
                                    </td>
                                    <td>Connected</td>
                                    <td><i class=""></i>{{item.name}}
                                    </td>
                                    <td><a href="{{ item|param:'url' }}" target="_blank">{{ item|param:'url' }}</a></td>
                                    <td>{{item.date_created}}</td>
                                </tr>
                            {% endif %}
                        {% else %}
                            <tr style="text-align: center; background-color: grey">
                                <td>
                                    <a title="Link account  " type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-danger"
                                        role=button href="{% url 'core:link-account' project.id item.id  %}">
                                         <i class="fa fa-link fa-1x tool ic-w mx-1"></i>
                                    </a>
                                </td>
                                <td>Not Connected</td>
                                <td><i class=""></i>{{item.name}}&nbsp;&nbsp;<button disabled
                                        class="btn btn-outline-dark btn-xs rounded" role=button>{{item.tag_tool|lower}}</button>
                                </td>
                                <td><a href="{{ item|param:'url' }}" target="_blank">{{ item|param:'url' }}</a></td>
                                <td>{{item.date_created}}</td>
                            </tr>
                    {% endif %}
                    {% endfor %}
                </tbody>
            </table>
        </div>

        <button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>


        <input type="submit" class="btn btn-primary" value="Next">
    </form>
    <br>
    {% endif %}

    {% endif %}

    <script>
        function validateForm() {
            var table = $("#table");
            var radiotoshow = table.find("input[type=radio]");
            if (radiotoshow.length == 0) {
                $('#myModal').modal('show')
              return false;
            }
          }
    </script>   

    {% endblock %}

openlink/core/templates/tools/json_list.html
{{json_tree|safe}}

openlink/core/templates/tools/list_tool_project.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% load param %}
{%comment%}
{% block content %}

<a class="btn btn-dark" href="{% url 'core:tools-new' %}" style="position: absolute; right: 0;">Add tool...</a>

<h1 class="display-titre" style="background-color: rgb(255, 255, 255)">My Tools</h1>

<div class="container">
    <table id="table" data-page-length='25' class="table table-striped table-bordered ">
        <thead class="thead-dark">
            <tr>
                <th>Tool name</th>
                <th>Url host</th>
                <th>Creation date</th>
            </tr>
        </thead>
        <tbody>
            {% for obj in list_tools_project %}
            <tr>
                <td>{{ obj.name }}</td>
                <td><a href="{% url 'core:get_tool_info_project' obj.id %}">{{ obj|param:'url' }}</a></td>
                <td>{{ obj.date_created }}</td>
            </tr>
            {% empty %}
            <tr>
                <td colspan="4">No data</td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</div>

{% endblock %}
{%endcomment%}

{% block content %}

<section>
    <h4 class style="cursor: default;">Manage Tools</h4>

    <div class="row">
        <div class="col-sm-6">
            <span class="badge badge-pill badge-secondary">{{ list_tools_project|length }}</span>
            <span class="texte-badge">tools found</span>
        </div>
        <div class="col-sm-6 text-right">
            <a class="add-link btn btn-primary" href="{% url 'core:select-connector-project' project.id %}">Add
                tool</a>
        </div>
    </div>

    <table id="table" class="table table-striped table-bordered table-hover">

        <thead>
            <tr>
                <th>Tool name</th>
                <th>Url host</th>
                <th>Creation date</th>
                <th>Author</th>
                <th>Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for obj in list_tools_project %}
            <tr>
                <td><i class="fa fa-wrench fa-1x tool ic-w mx-1"></i><a
                        href="{% url 'core:tool-project' project.id obj.id %}">{{ obj.name }}</a>&nbsp;&nbsp;<button
                        disabled class="btn btn-outline-dark btn-xs rounded" role=button>{{obj.tag_tool|lower}}</button>
                </td>
                <td>
                    <div data-toggle="popover" data-trigger="hover" data-placement="right"
                        title="{{ obj|param:'url'|truncatechars:40 }}" data-container="body" data-html="true">
                        <a href="{{ obj|param:'url' }}" target="_blank">{{ obj|param:'url'|truncatechars:40 }}</a>
                    </div>
                </td>
                <td>{{ obj.date_created }}</td>
                <td>{{ obj.author }}</td>
                <td>
                    {% if user|stringformat:"s" == obj.author|stringformat:"s" %}
                        <a title="Edit" type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-primary"
                            href="{% url 'core:tools-edit-project' project.id  obj.id %}"><i class="fas fa-edit"></i></a>
                        {% comment %} <a type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-secondary"
                            href="{% url 'core:toolsparam-edit-project' project.id  obj.id %}">Edit tool
                            parameters</a> {% endcomment %}
                    {% endif %}

                    {% if obj in tool_list_linked %}
                        <a title="Link account  " type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-success"
                            role=button href="{% url 'core:link-account' project.id obj.id %}">
                             <i class="fa fa-link fa-1x tool ic-w mx-1"></i>
                        </a>
                    {% else %}
                        <a title="Link account  " type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-danger"
                            role=button href="{% url 'core:link-account' project.id obj.id %}">
                             <i class="fa fa-link fa-1x tool ic-w mx-1"></i>
                        </a>
                    {% endif %}

                    {% if user|stringformat:"s" == obj.author|stringformat:"s" %}
                        <a title="Delete" type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-danger"
                                role=button href="{% url 'core:delete_tool' project.id obj.id %}"><i
                                    class="fa fa-trash-alt fa-1x"></i></a>
                    {% endif %}

                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
    <button type="button" class="btn btn-secondary"><a
            href="{% url 'core:projects-details' project.id %}">Back</a></button>
    {% comment %} <i class="fa fa-arrow-left fa-1x ic-w mx-1  "></i><a
        href="{% url 'core:projects-details' project.id %}">Back </a> {% endcomment %}

    </div>

</section>
{% endblock %}

openlink/core/templates/tools/new-choose-connector-project.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% load crispy_forms_tags %}

{% block content %}

<h4 class="display-titre" style="background-color: rgb(255, 255, 255)">Select a tool connector</h4>
<br>
<form action="{% url 'core:select-connector-project' project.id %}" method="GET">
    {% csrf_token %}
    {{ form | crispy }}

    <button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>

    <input class="btn btn-primary" type="submit" value="Next">
</form>

<script>

document.addEventListener('input', function (event) {

    if (event.target.id == 'id_connector') {
        document.getElementById("id_name").value = event.target.value.replace('Connector', '');
    }

}, false);

</script>

{% endblock %}

openlink/core/templates/tools/tool_info_project.html
{% extends "base.html" %}
{% load static i18n %}
{% load param %}
{% block content %}

{% for tool in tool_list %}
<h4 style="background-color: rgb(255, 255, 255)">{{ tool.name }}</h4>


<div class="container">
    <span>
        <h5><i class="fas fa-wrench"></i> Tool details</h5>
    </span>
    <ul>
        <li><b>Name:</b> {{ tool.name }}&nbsp;&nbsp; <a title="Edit" type="button" style="position: absolute; margin-right: 50%; right: 0" class="btn-sm btn rounded btn-primary"
                href="{% url 'core:tools-edit-project' project.id  tool.id %}"><i class="fas fa-edit"></i></a></li>
        <li><b>url:</b> {{tool|param:'url'}}</li>
        <li><b>Date:</b> {{ tool.date_created }}</li>

    </ul>
</div>

{% endfor %}

<button type="button" class="btn btn-secondary" onClick="window.history.go(-1);"> Back </button>


</body>



{% endblock %}